/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using com.db4o.inside.query;
using com.db4o.test.nativequeries;

namespace com.db4o.test.inside.query
{
	using System;
	using com.db4o.nativequery.expr;
	using com.db4o.nativequery.expr.cmp;
	
	public class QueryExpressionBuilderTestCase
	{
		public void TestNameEqualsTo()
		{
			Expression expression = ExpressionFromPredicate(typeof(NameEqualsTo));
			Tester.ensureEquals(
				new ComparisonExpression(
				new FieldValue(1, "name"),
				new FieldValue(0, "_name"),
				ComparisonOperator.EQUALS),
				expression);
		}
	
		public void TestHasPreviousWithPrevious()
		{
			// candidate.HasPrevious && candidate.Previous.HasPrevious
			Expression expression = ExpressionFromPredicate(typeof(HasPreviousWithPrevious));
			Expression expected = 
				new AndExpression(
				new NotExpression(
				new ComparisonExpression(
				new FieldValue(1, "previous"), 
				new ConstValue(null),
				ComparisonOperator.EQUALS)),
				new NotExpression(
				new ComparisonExpression(
				new FieldValue(1, new string[] { "previous", "previous" }),
				new ConstValue(null),
				ComparisonOperator.EQUALS)));

			Tester.ensureEquals(expected, expression);
		}

		private Expression ExpressionFromPredicate(Type type)
		{
			// XXX: move knowledge about IMethodDefinition to QueryExpressionBuilder
			return QueryExpressionBuilder.FromMethod(type.GetMethod("Match"));
		}
	}
}
